
local whitelist = {
  LuaItemStack = true,
}
local blacklist = {
  LuaLazyLoadedValue = true, -- this object cannot be serialized
}

-- this function will make an array of LuaObjects from event data
local get_only_luaobj = function(event)
  local tbl = {}
  local deepscan
  deepscan = function(obj)
    local t = type(obj)
    if t == 'table' and type(obj.__self) == 'userdata' and obj.object_name then
      -- currently set as whitelist
      -- if not blacklist[obj.object_name] then
      if whitelist[obj.object_name] then
        tbl[#tbl+1] = obj
      end
    elseif t == 'table' then
      for k, v in pairs(obj) do
        deepscan(v)
      end
    end
  end
  deepscan(event)
  return tbl
end

-- this function gets event name string from event id number
local get_event_name = function(eventid)
  for k, v in pairs(defines.events) do
    if eventid == v then return k end
  end
  return eventid
end

-- this event handler writes LuaObject references in global table during game life time.
local logger = function(event)
  local name = get_event_name(event.name)
  if not global[name] then global[name] = {} end
  global[name][#global[name] + 1] = get_only_luaobj(event)
end

-- monitor every events
for k, v in pairs(defines.events) do
  if k == 'on_player_created' then
    script.on_event(v, function(event)
      logger(event)
      -- insert an placeable item
      game.players[event.player_index].set_quick_bar_slot(1, 'wooden-chest')
      game.players[event.player_index].insert('wooden-chest')
    end)
  else
    script.on_event(v, logger)
  end
end
